<?php
//*************************************************************************************
//*************************************************************************************
//   NEW ACCOUNT - WORDPRESS SELF-REGISTRATION WITH RAPID
//*************************************************************************************
//*************************************************************************************


function rpsl_newregistration_qrcode() {
// This part of Wordpress uses tables for layout rather than divs
	$logoimg = esc_url( plugin_dir_url( __FILE__ ) . "images/rapidwm.png" ); 
	$blank   = esc_url( plugin_dir_url( __FILE__ ) . "images/white.jpg" ); 

	// i18n Strings
	$mTitle           = esc_html__('RapID Registration', 'rp-securelogin');
	$mScanQR          = __('Scan the QR code with the <a href="https://www.intercede.com/rapidsl" target="_blank">RapID SL</a> app, or just tap the code on your phone to register on this site.', 'rp-securelogin');
	$mScanWithRapid   = esc_html__('Scan with your RapID app to register', 'rp-securelogin');
	$mUseRapid        = esc_html__('Use RapID - No More Passwords!', 'rp-securelogin');
	$mFirstName       = esc_html__('First name', 'rp-securelogin');
	$mLastName        = esc_html__('Last name', 'rp-securelogin');
	$mNickName        = esc_html__('Nick name', 'rp-securelogin');
	$mDeviceName      = esc_html__('Phone', 'rp-securelogin');
	$mAlreadyLoggedOn = esc_html__('You are already logged on as: ', 'rp-securelogin');
	$mCheckDetails    = esc_html__('Please check the details, then click Register to continue', 'rp-securelogin');
	$mError           = esc_html__('Error ', 'rp-securelogin');
	$mDataError       = esc_html__('Possibly invalid data provided: ', 'rp-securelogin');
 
	$action  = isset($_REQUEST['action']) ? sanitize_text_field( $_REQUEST['action'] ) : 'login';
	if ($action == "register") {
		?>
		<div id="rpsl_rapidlogon_container" style="display:none;">
			<h3 id="rpsl_newacc_header"><?php echo $mTitle ?></h3>
			<span name='rpsl_newacc_prompt'><?php echo $mScanQR ?></span>
			<br/>
			<div class="rpsl_outer_div" id="rpsl_newacc_qrdiv">
				<div class="rpsl_qr_backend_div">
					<a name="rpsl_qr_url" href=''>
					<img class="rpsl_qr_img"   id="rpsl_newacc_qr" name="rpsl_newacc_qr" src="<?php echo $blank;     ?>" title="<?php echo $mScanWithRapid ?>"  />
					</a>
					<div>
						<img class="rpsl_logo_img" id="rapidlogo"    name="rapidlogo"    src="<?php echo $logoimg; ?>" title="<?php echo $mUseRapid ?>" onClick="rpsl_newRequest();" />
					</div>
					<span name='rpsl_newacc_error'>Awaiting user registration.</span>
				</div>
				<br /><br />
				<p>Alternatively, please fill out the details below and click register.</p><br/>
			</div>
			<?php
			$rpsl_newacc_firstname = ( ! empty( $_POST['rpsl_newacc_firstname'] ) ) ? trim( $_POST['rpsl_newacc_firstname'] ) : '';
			$rpsl_newacc_lastname = ( ! empty( $_POST['rpsl_newacc_lastname'] ) ) ? trim( $_POST['rpsl_newacc_lastname'] ) : '';
			$rpsl_newacc_nickname = ( ! empty( $_POST['rpsl_newacc_nickname'] ) ) ? trim( $_POST['rpsl_newacc_nickname'] ) : '';
			$rpsl_newacc_device = ( ! empty( $_POST['rpsl_newacc_device'] ) ) ? trim( $_POST['rpsl_newacc_device'] ) : '';
			$rpsl_newacc_uuid = ( ! empty( $_POST['rpsl_newacc_uuid'] ) ) ? trim( $_POST['rpsl_newacc_uuid'] ) : '';
			?>
			<div id="rpsl_newacc_extrafields" style="display:none"><br />
				<label for="rpsl_newacc_firstname"><?php echo $mFirstName ?><br/>
				<input type="text"   id="rpsl_newacc_firstname" name="rpsl_newacc_firstname" style="width:100%" value="<?php echo esc_attr(wp_unslash( $rpsl_newacc_firstname ) ); ?>"></label><br/>

				<label for="rpsl_newacc_lastname" ><?php echo $mLastName  ?><br/>
				<input type="text"   id="rpsl_newacc_lastname"  name="rpsl_newacc_lastname"  style="width:100%" value="<?php echo esc_attr(wp_unslash( $rpsl_newacc_lastname ) ); ?>"></label><br/>

				<label for="rpsl_newacc_nickname" ><?php echo $mNickName  ?><br/>
				<input type="text"   id="rpsl_newacc_nickname"  name="rpsl_newacc_nickname"  style="width:100%" value="<?php echo esc_attr(wp_unslash( $rpsl_newacc_nickname ) ); ?>"></label><br/>

				<label for="rpsl_newacc_device"   ><?php echo $mDeviceName  ?><br/>
				<input type="text"   id="rpsl_newacc_device"    name="rpsl_newacc_device"    style="width:100%" value="<?php echo esc_attr(wp_unslash( $rpsl_newacc_device ) ); ?>"></label><br/>

				<input type="hidden" id="rpsl_newacc_uuid"      name="rpsl_newacc_uuid"      style="width:100%"  value="<?php echo esc_attr(wp_unslash( $rpsl_newacc_uuid ) ); ?>"></label>
			</div>
		</div>
		
		<script type='text/javascript' >
			var rpsl_newacc_session   = "";
			var rpsl_newacc_dots      = "";
			var rpsl_admin_ajaxurl   = "<?php echo admin_url('admin-ajax.php'); ?>";
			var rpsl_ajaxurl     = "<?php echo RPSL_Configuration::rpsl_ajax_endpoint() ?>";
			var rpsl_checkUserInfo_timeout; if (typeof rpsl_checkUserInfo_timeout === 'undefined') rpsl_checkUserInfo_timeout = 0;
			var rpsl_refresh_qrcode = false;
			var rpsl_refresh_timeout;
			
			function rpsl_setNewAccountQR() {  // Calls to the server to get the QR code src
				jQuery.ajax({
					url :  rpsl_admin_ajaxurl, type: 'POST', data: {'action' :'rpsl_generate_userinfo_qrcode'},	dataType: 'json',
					success:  function(data) {
								if(data.status == "error"){
									rpsl_setNewAccountErrorMessage("Error: " + data.message);
									jQuery("#rpsl_newacc_qrdiv").hide();
									jQuery("#rpsl_newacc_header").hide();
									return;
								} else {
									rpsl_newacc_session = data.rpsessionid;
									rpsl_setNewAccountImages(data.qrbase64, data.qrdata);
									clearTimeout(rpsl_refresh_timeout);
									rpsl_refresh_timeout = null;
									rpsl_poll_for_user_data();
								}
							},
					error:   function(errorThrown){
								rpsl_setNewAccountErrorMessage("Error: " + errorThrown);
							}
				});   
			};	
			
			function rpsl_poll_for_user_data() {

				// Sessions will timeout, to cover this, refresh the QR code if this token is set
				// Has to be part of poll for login as it will override the assoc session variable
				// Which has to be correct for the form post.
				if(rpsl_refresh_qrcode)	{
					rpsl_refresh_qrcode = false;
					rpsl_wplogin_code_requested = false;
					rpsl_setNewAccountQR();
					return;
				}
				
				// Only set timeout if it is not 0
				if(!rpsl_refresh_timeout) { rpsl_refresh_timeout = setTimeout(rpsl_refreshQRCodeToken, 1080000); }
				
				// Avoid multiple polling timeouts from duplicate sections on the form
				if (rpsl_checkUserInfo_timeout != 0) clearTimeout(rpsl_checkUserInfo_timeout);
				rpsl_checkUserInfo_timeout =	setTimeout(rpsl_checkUserInfo, <?php echo RPSL_Configuration::$rpsl_ajax_timeout ?>);
			}
			
			function rpsl_refreshQRCodeToken()
			{
				rpsl_refresh_qrcode = true;
			}
			
			function rpsl_setNewAccountImages(base64src, data){
				jQuery('[name="rpsl_newacc_qr"]').attr("src", base64src);
				jQuery('[name="rpsl_qr_url"]').attr("href", "rapid02://qr?sess=" + data);
			};
			
			function rpsl_setNewAccountErrorMessage(mess){
				var message = mess;
				if (message == "Error: [object Object]") { message = "Errors: Session has timed out. Please refresh the page"; }
				
				jQuery('[name="rpsl_newacc_error"]').html(message);
			};
			
			function rpsl_setNewAccountPrompt(mess){
				jQuery('[name="rpsl_newacc_prompt"]').html(mess);
			};
			
			function rpsl_checkUserInfo() {  // Checks whether user details have been supplied yet
				jQuery.ajax({ url: rpsl_ajaxurl, type: 'POST', data: {'action' :'rpsl_check_userinfo', 'rpsession' : rpsl_newacc_session}, dataType: 'json',
					success:function(rpsl_newacc_data) {

						rpsl_newacc_dots += "."; 
						if (rpsl_newacc_dots.length > 10) { rpsl_newacc_dots = ".";}


						if(rpsl_newacc_data.status == 100){
							// waiting registration
							rpsl_setNewAccountErrorMessage(rpsl_newacc_data.message + rpsl_newacc_dots);
							rpsl_poll_for_user_data();
							return;
						}

						if(rpsl_newacc_data.status == 200){
							// registration received
							
							jQuery("#rpsl_newacc_uuid").val(rpsl_newacc_data.uuid);
							jQuery("#user_login").val(rpsl_newacc_data.userdata.contact.email);
							jQuery("#user_email").val(rpsl_newacc_data.userdata.contact.email);
							jQuery("#rpsl_newacc_firstname").val(rpsl_newacc_data.userdata.contact.firstName);
							jQuery("#rpsl_newacc_lastname").val(rpsl_newacc_data.userdata.contact.lastName);
							jQuery("#rpsl_newacc_nickname").val(rpsl_newacc_data.userdata.contact.firstName);
							jQuery("#rpsl_newacc_device").val(rpsl_newacc_data.userdata.contact.phoneName);

							rpsl_setNewAccountPrompt("<?php echo $mCheckDetails ?>");
							rpsl_setNewAccountErrorMessage("");
							jQuery("#rpsl_newacc_qrdiv").hide();
							jQuery("#rpsl_newacc_extrafields").show();
						}
					},
					error: function(errorThrown){
						rpsl_setNewAccountErrorMessage("Error: " + errorThrown);
					}
				});   
			};	

			
			jQuery(document).ready(function($) {
				if(jQuery("#rpsl_newacc_uuid").val()){
					rpsl_setNewAccountPrompt("<?php echo $mCheckDetails ?>");
					rpsl_setNewAccountErrorMessage("");
					jQuery("#rpsl_newacc_qrdiv").hide();
					jQuery("#rpsl_newacc_extrafields").show();
				} else {
					rpsl_setNewAccountQR();
				}

				jQuery('#rpsl_rapidlogon_container').prependTo('#registerform');
				jQuery('#rpsl_rapidlogon_container').fadeIn();
			})
		</script>

		<?php
	}
}

//*************************************************************************************
// This generates a rapid session ID and QR code for creating a new account
// It is run via an Ajax call to avoid the over-zealous caching of some WP hosts
// QR code contains: <version>R<platform>#<site name>#<request ID>#<login name>#<url>
//*************************************************************************************
function rpsl_generate_userinfo_qrcode() {
	global $wpdb;

	// Check the current user is not set
	$currentuser = wp_get_current_user();
	if ( $currentuser && $currentuser->ID != 0) {
		$message = "logged on as " . $currentuser->user_login;
		$data = array("status"=>"error", "message"=>$message);
		rpsl_echo(json_encode($data));
		die(); 
	}  
	
	$loginname = "";
	
	// Generate a pseudo-random session ID, prefix with {Forum}
	$d = rpsl_delim();
	$ht_sessionid = session_id();
	$rpsl_sessionid = rpsl_UUID::v4();
	
	// Create an entry in the session table
	$table_name = $wpdb->prefix . "rpsl_sessions";

	$insert = $wpdb->prepare("INSERT INTO " . $table_name .	" (sessionid, rpsession, loginname, action, userdata, requested) " .
				"VALUES (%s, %s, %s, 'userinfo', 'waiting', Now())", $ht_sessionid, $rpsl_sessionid, $loginname);
	$results = $wpdb->query( $insert );
	
	$qr_data = rpsl_qr_data("R", $rpsl_sessionid, $loginname);
	$qr_base64 = rpsl_qr_base64($qr_data);
	rpsl_trace("New User Info QR created for:  $qr_data");
	
	$data = array("rpsessionid"=>$rpsl_sessionid, "qrbase64"=>$qr_base64, "qrdata"=>$qr_data);
	die(rpsl_echo(json_encode($data)));
}

//*************************************************************************************
// This Ajax function checks the supplied POSTed envelope and matches it to the
// 'userinfo' request in the database, which it then updates with the info
// Returns a RapID Request ID or error message
// If the phone has a credential for this website already it blocks the submission
//*************************************************************************************
function rpsl_set_account_info () {
	global $wpdb;

	$dataJson = file_get_contents("php://input");     //DIAG	echo "Data is: $dataJson";
	$data     = json_decode($dataJson);               //DIAG	print_r($data);
	$session  = $data->session;
	$userdata = $data->userdata;
	$uuid     = rpsl_UUID::v4();
	
	if(!property_exists($data, 'session') || !property_exists($data,'userdata'))
	{
		rpsl_diag("Rapid Set Account Info: insufficient data supplied to set account info");
		die;
	}

	// Select to see if session details match a known user registration request.
	$table_name = $wpdb->prefix . "rpsl_sessions";
	$select = $wpdb->prepare("SELECT COUNT(*) as howmany FROM " . $table_name . " WHERE rpsession = %s AND action = 'userinfo'", sanitize_text_field( $session ));
	$found  = $wpdb->get_var($select);
	
    if ($found > 0) {
		// Use the new random user ID for the RapID service request
		$ht_sessionid = session_id();
		$rpsl_request_message = null;
		$rpsl_requestid = rpsl_get_new_rapid_request($uuid, $rpsl_request_message);
	
		if(!empty($rpsl_request_message))
		{
			rpsl_echo($rpsl_request_message);
			die;
		}

		if(empty($rpsl_requestid)){
			rpsl_trace("Call to rpsl_get_new_rapid_request was successful, but no rpsl_requestid returned");
			rpsl_echo("Error: Please contact your system administrator, unable to request a credential");
			die;
		}
		
		// The session record that was requested will be cleaned up when its age > 20 minutes
		// Now the Request Id has succeeded -  Create the file that's being polled by the registration page:
		$data->uuid = $uuid;
		$data_json = json_encode($data);
		rpsl_create_session_token_file($session, $data_json);
		rpsl_delete_session_row($session);
	
		rpsl_echo( $rpsl_requestid );
		rpsl_diag("User details ok $session : $rpsl_requestid");
	} else {
		rpsl_echo("Error: user details could not be set."); 
		rpsl_diag("Unable to set user info for $session");
		rpsl_diag(print_r ( $data ));
	}

 die; // Always die in functions echoing Ajax content
}


//*************************************************************************************
// This WordPress hook fires immediately after a new user account is created
// from the Register user form. It pulls any additional fields that were posted
// and sets the corresponding user attributes in WordPress
//*************************************************************************************
function rpsl_register_new_user ($userid) {
	$user_firstname = isset( $_POST['rpsl_newacc_firstname'] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_firstname']) ) : 'firstname';
	$user_lastname  = isset( $_POST['rpsl_newacc_lastname' ] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_lastname' ]) ) : 'lastname';
	$user_nickname  = isset( $_POST['rpsl_newacc_nickname' ] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_nickname' ]) ) : $user_firstname;
	$uuid           = isset( $_POST['rpsl_newacc_uuid'     ] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_uuid'     ]) ) : '';
	$devicename     = isset( $_POST['rpsl_newacc_device'   ] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_device'   ]) ) : 'My Phone';
	$user_display   = isset( $_POST['rpsl_newacc_display'  ] ) ? sanitize_text_field( trim($_POST['rpsl_newacc_display'  ]) ) : $user_firstname . ' ' . $user_lastname;

	wp_update_user( array(
		'ID'            => $userid,
		'first_name'    => $user_firstname,
		'last_name'     => $user_lastname,
		'nickname'      => $user_nickname,
		'display_name'  => $user_display,
	));

	// Trap duplicates  		
	$user = rpsl_get_user_by_uuid($uuid);
	if (is_null($user)) {
		// Associate the UUID with this account
		if(!empty($uuid)){ rpsl_add_device( $userid, $uuid, $devicename); }
	}
	return;	
}