<?php 
//*************************************************************************************
//*************************************************************************************
// WordPress Rapid Secure Login Plugin Settings Control
//*************************************************************************************
//*************************************************************************************

//*************************************************************************************
function rpsl_admin_menu() {
	add_options_page ( "RapID Secure Login", "RapID", "manage_options", "rpsl-plugin-settings", "rpsl_settings_page");
}

//*************************************************************************************
function rpsl_settings_page() {

?>
	<script type="text/javascript">
		var rpsl_admin_ajaxurl		= "<?php echo admin_url('admin-ajax.php'); ?>";
		var rpsl_ajaxurl			= "<?php echo RPSL_Configuration::rpsl_ajax_endpoint() ?>";
		var rpsl_toggleManual		= false; 
		var rpsl_timeout			= "<?php echo RPSL_Configuration::$rpsl_ajax_timeout ?>";
		var rpsl_site_configured	= "<?php echo rpsl_site_configured() ?>";
	</script>
<?php
	wp_enqueue_script('rpsl_configure_wordpress_registration');

	// i18n Strings
	$mHeader          = __('RapID Secure Login Settings', 'rp-securelogin');
	$mInstructions    = __('To use RapID Secure Login for your WordPress site, register your site and collect your Administrator credential to login using your mobile phone.<br/><br/>');
	
	$mInstructions   .= __('<strong>Register:</strong><br/>');
	$mInstructions   .= __('1. Install the RapID Secure Login app on your phone.<br/>', 'rp-securelogin');
	$mInstructions   .= __('2. Use the app to scan the QR code below.<br/>', 'rp-securelogin');
	$mInstructions   .= __('3. Follow the instructions in the app to create a RapID account. <br/><br/>', 'rp-securelogin');
	$mInstructions   .= __('Once registered, you can use your phone to login to your WordPress site and administer your account through the <a target="_blank" href="https://rapidportal.intercede.com/">RapID dashboard</a>.<br/><br/>', 'rp-securelogin');
				
	$mSupport 		  = __('<strong>Support</strong><br/>', 'rp-securelogin');
	$mSupport  		 .= __('For additional information about RapID Secure Login, please navigate to the <a target="_blank" href="https://forums.intercede.com/forum/rapid-sl/">support forum.</a><br/>', 'rp-securelogin');

	$mShortcode       = __('<br/><strong>Adding RapID to your own page</strong><br/>', 'rp-securelogin');
	$mShortcode       .= __('To add a RapID login control to your own page, simply use the shortcode:  <b>[rpsl_secure_login]</b><br/>', 'rp-securelogin');
	$mShortcode2      = __('You can modify each instance of the shortcode using "showregister" and "redirect_to" parameters<br/>', 'rp-securelogin');
	$mShortcode3      = __('For example :  <b>[rpsl_secure_login showregister="false" redirect_to="/forum"]</b><br/><br/>', 'rp-securelogin');
	$mShortcode4      = __('To add a Register QR Code and a Device List use :  <b>[rpsl_my_devices showheader="true" showblurb="true" showregister="true"]</b><br/>', 'rp-securelogin');
	
	$mCERLabel        = __('Upload your RapID Trusted CA Certificate CER file  ', 'rp-securelogin');
	$mPFXLabel        = __('Upload your RapID Server authentication key PFX file ', 'rp-securelogin');
	$mPswLabel        = __('PFX file password', 'rp-securelogin');
	$mLoginLabel      = esc_html__('Display password login ', 'rp-securelogin');
	$mLoginYes        = esc_html__('Always', 'rp-securelogin');
	$mLoginNo         = esc_html__('Never', 'rp-securelogin');
	$mLoginClick      = esc_html__('Click logo to show it', 'rp-securelogin');
	$mSiteName        = esc_html__('RapID Site Name ', 'rp-securelogin');
	$mSiteId          = esc_html__('Unique RapID Site ID ', 'rp-securelogin');
	$mError           = esc_html__('Error: ', 'rp-securelogin');
	$mCACertOk        = esc_html__('Your RapID trusted CA certificate was successfully imported', 'rp-securelogin');
	$mAuthKeyOk       = esc_html__('Your RapID service authentication key was successfully imported', 'rp-securelogin');

	// i18n Strings
	$mConfigStatus		= esc_html__('Current configuration status',         'rp-securelogin');
	$mCACertOK  		= esc_html__('Trusted CA Certificate is OK',         'rp-securelogin');
	$mCACertMissing		= esc_html__('Trusted CA Certificate is missing',    'rp-securelogin');
	$mRapIDKeyOK		= esc_html__('RapID Service Key is OK',              'rp-securelogin');
	$mRapIDKeyMissing	= esc_html__('RapID Service Key is missing',         'rp-securelogin');
	$mRapIDCertOK		= esc_html__('RapID Service Certificate is OK',      'rp-securelogin');
	$mRapIDCertMissing	= esc_html__('RapID Service Certificate is missing', 'rp-securelogin');

	// i18n Strings - Wordpress Configuration
	$logoimg 			= esc_url( plugin_dir_url( __FILE__ ) . "images/rapidwm.png" ); 
	$logobig 			= esc_url( plugin_dir_url( __FILE__ ) . "images/rapid.png" ); 
	$blank   			= esc_url( plugin_dir_url( __FILE__ ) . "images/white.jpg" ); 
	$mUseRapid        	= esc_html__('Use RapID - No More Passwords!', 'rp-securelogin');

	// Get the login value of the radio button.
	$show_login = rpsl_show_login();
		
	?>
		<div class="wrap"><!-- Config and instructions header -->
			<h2> <?php echo $mHeader ?> </h2>	
			<?php echo $mInstructions; ?>

			<div class="rpsl_outer_div">
					<div class="rpsl_qr_div" id="rpsl_big_logo" name="rpsl_big_logo">
						<img class="rpsl_qr_img" src="<?php echo $logobig; ?>" title="RapID" <?php echo (rpsl_site_configured() ? 'onClick="rpsl_setSiteRegistrationQR();"' : '') ?> />
					</div>
					
					<div class="rpsl_qr_div" id="rpsl_qr_code" name="rpsl_qr_code" style="display:none">
						<a name="rpsl_site_registration_url" href=''>
						<img class="rpsl_qr_img"   id="rpsl_site_registration_qr" name="rpsl_site_registration_qr" src="<?php echo $blank;   ?>" title="RapID Site Registration" />
						</a>
						<div id="rpsl_small_logo" name="rpsl_small_logo" style="display:none">
							<img class="rpsl_logo_img_click" id="rapidlogo"    name="rapidlogo"    src="<?php echo $logoimg; ?>" title="<?php echo $mUseRapid ?>" />
						</div>
					</div>
					<div class="rpsl_qr_div">
						<span class="rpsl_qr_message" name="rpsl_qr_message"><?php echo (rpsl_site_configured() ? 'Site configured.' : '') ?></span><br /><br />
					</div>
					<span name="rpsl_reconfigure_message"><?php echo (rpsl_site_configured() ? 'Click the RapID logo to reconfigure the site.' : '') ?></span>
			</div>
			<br/>
			<?php echo $mSupport; ?>

			<div class="wrap">
				<input name="btn_rapid_manual_configuration"  id="btn_rapid_manual_configuration" value="Manual Configuration" class="button-primary" onclick="jQuery('#rpsl_manual_configuration').toggle();" style="text-align:center;">
			</div>
			<div id="rpsl_manual_configuration">
				<br />
				<div style="background-color: #eeee66"><b>
				<?php
				$show_manual = false;
				if (!empty($_POST)) {
					// Upload the CER file
					if (isset($_POST['upload_trusted_ca_cert']) && $_FILES) {
						$show_manual = true;
						check_admin_referer("upload_trusted_ca_cert", "rp_cer_nonce");  // Security check
						$uploaded_file = $_FILES['trusted_ca_cert'];
						// Check size and file type
						$expected_type = 'application/x-x509-ca-cert';
						$uploaded_type = $uploaded_file['type'];
						if ($uploaded_type == $expected_type) {
							$filesize = $uploaded_file['size'];
							if ( $filesize > 1000 && $filesize < 3000 ) {
								// Get contents of issuer certificate
								$file_content = file_get_contents($uploaded_file['tmp_name']);
								$ok = rpsl_add_issuer_certificate($file_content);
								if ($ok) { 
									echo __('Your RapID trusted CA certificate was successfully imported', 'rp-securelogin');
								} else {
									echo __('<b>Error</b> - unable to import this file, it is corrupted.', 'rp-securelogin');
								}
							} else {
								printf( __('<b>Error</b> - this file is not an acceptable size - %s bytes. Expected between 1000 and 3000 bytes', 'rp-securelogin'), $filesize) ;
							}
						} else {
							printf( __('<b>Error</b> - this file is not the correct type - %s. Expected %s', 'rp-securelogin'), $uploaded_type, $expected_type) ;
						}
					}
					
					// Upload the PFX file
					if (isset($_POST['upload_rapid_server_key']) && $_FILES) {
						$show_manual = true;
						check_admin_referer("upload_rapid_server_key", "rp_pfx_nonce"); // Security check
						$password = sanitize_text_field( $_POST['pfx_password']) ;
						$uploaded_file = $_FILES['rapid_server_key'];
						$expected_type = 'application/x-pkcs12';
						$uploaded_type = $uploaded_file['type'];
						// Check size and file type
						if ($uploaded_type == $expected_type) {
							$filesize = $uploaded_file['size'];
							if ($filesize > 1000 && $filesize < 4000 ) {
									// Attempt to process the PFX file
									$file_content = file_get_contents($uploaded_file['tmp_name']); 
									$ok = rpsl_import_sac_certificate($file_content, $password);
									if ($ok) {
										echo __('Your RapID service authentication key was successfully imported', 'rp-securelogin');
									} else {
										echo __('<b>Error</b> - unable to import your RapID service authentication key. Please check the password', 'rp-securelogin');
									}
							} else {
								printf( __('<b>Error</b> - this file is not an acceptable size - %s bytes. Expected between 1000 and 3000 bytes', 'rp-securelogin'), $filesize) ;
							}
						} else {
							printf( __('<b>Error</b> - this file is not the correct type - %s. Expected %s', 'rp-securelogin'), $uploaded_type, $expected_type) ;
						}
						
					}
					
					// Set site name or id
					if (isset($_POST['set_rapid_site_name'])) {
						check_admin_referer("set_rapid_site_name", "rpsl_set_site_name_nonce"); // Security check
						$site_name = sanitize_text_field( $_POST['rapid_site_name'] );
						if ($site_name != "") {
							rpsl_set_site_name($site_name);
						}
					}

					if (isset($_POST['set_rapid_login_pw'])) {
						check_admin_referer("set_rapid_login_pw", "rpsl_set_rapid_login_pw"); // Security check
						$show_login   = sanitize_text_field( $_POST['rapid_login_pw'] );
						if ($show_login != "") {
							rpsl_set_show_login($show_login);
						}
					}
				}
							
				$status = rpsl_db_check_configuration();
				//DIAG echo rp_cert_folder();
				$statusReport = "";
				if ($status['CACert'])        { $statusReport .= $mCACertOK . "<br/>";    } else { $statusReport .= $mCACertMissing . "<br/>";    };
				if ($status['RapidAuthKey'])  { $statusReport .= $mRapIDKeyOK . "<br/>";  } else { $statusReport .= $mRapIDKeyMissing . "<br/>";  };
				if ($status['RapidAuthCert']) { $statusReport .= $mRapIDCertOK . "<br/>"; } else { $statusReport .= $mRapIDCertMissing . "<br/>"; };
				if($show_manual){ ?>
				
				<script type="text/javascript">
					rpsl_toggleManual = <?php echo ($show_manual == true ? "true" : "false")  ?>;
				</script>
				
				<?php
				}
				?>
			</b></div> <!-- Close background color div-->
			<b><?php echo $mConfigStatus ?> </b><br/> 
			<?php echo $statusReport ?>
				<div class="wrap">
				<form method="post" enctype="multipart/form-data">
						<table class="form-table">
							<tr><th style="text-align:left"><label><?php echo $mCERLabel ?></label></th>
								<td>
									<fieldset>
									<input type="file"     name="trusted_ca_cert"  id="trusted_ca_cert" ><br><br>
									<input type="submit"   name="upload_trusted_ca_cert"  id="upload_trusted_ca_cert" 
										   value="Upload"  class="button-primary">
									</fieldset>
								</td>
							</tr> 
						</table>
						<?php wp_nonce_field("upload_trusted_ca_cert", "rp_cer_nonce"); ?>
					</form>
				</div>
				<div class="wrap">
					<form method="post" enctype="multipart/form-data">
						<table class="form-table">
							<tr><th style="text-align:left"><?php echo $mPFXLabel ?></th> 
							<td>
								<input type="file"     name="rapid_server_key" id="rapid_server_key"><br>
								<?php echo $mPswLabel ?>
								<input type="password" name="pfx_password"     id="pfx_password"    ><br><br>
								<input type="submit"   name="upload_rapid_server_key"  id="upload_rapid_server_key" value="Upload" class="button-primary">
							</td>
							<tr>
						</table>
						<?php wp_nonce_field("upload_rapid_server_key", "rp_pfx_nonce"); ?>
					</form>
				</div>
			</div> <!-- Close manual configuration div -->	
			<div>
				<?php echo $mShortcode . $mShortcode2 . $mShortcode3 . $mShortcode4; ?>
			</div>
		</div><!-- Close Config and instructions header -->
		<div class="wrap">
			<form method="post" enctype="multipart/form-data">
				<table class="form-table">
					<tr><th style="text-align:left"><?php echo $mSiteName ?></th> 
					<td>
						<fieldset>
						<input type="text"     name="rapid_site_name"      id="rapid_site_name"     value="<?php echo rpsl_site_name() ?>"><br><br>
						<input type="submit"   name="set_rapid_site_name"  id="set_rapid_site_name" value="&nbsp; Save &nbsp;" class="button-primary">
						</fieldset>
					</td>
					</tr> 
				</table>
				<?php wp_nonce_field("set_rapid_site_name", "rpsl_set_site_name_nonce"); ?>
			</form>
		</div>
		<div class="wrap">
			<form method="post" enctype="multipart/form-data">
				<table class="form-table">
					<tr><th style="text-align:left"><?php echo $mLoginLabel ?></th> 
						<td>
							<fieldset>
							<input type="radio"    name="rapid_login_pw"       id="rapid_login_pw_Yes"    value="Yes" 		<?php echo ($show_login=='Yes' ? 'checked' : '');?> ><?php echo $mLoginYes;   ?><br>
							<input type="radio"    name="rapid_login_pw"       id="rapid_login_pw_No"     value="No"  		<?php echo ($show_login=='No' ? 'checked' : '');?> ><?php echo $mLoginNo;    ?><br>
							<input type="radio"    name="rapid_login_pw"       id="rapid_login_pw_Click"  value="Click"		<?php echo ($show_login=='Click' ? 'checked' : '');?> ><?php echo $mLoginClick; ?>
							<br><br>
							<input type="submit"   name="set_rapid_login_pw"   id="set_rapid_login_pw" value="&nbsp; Save &nbsp;" class="button-primary">
							</fieldset>
						</td>
					</tr> 
				</table>
				<?php wp_nonce_field("set_rapid_login_pw", "rpsl_set_rapid_login_pw"); ?>
			</form>
		</div>		
	<?php
}

//*************************************************************************************
// Boolean conversion of rpsl_db_check_configuration
//*************************************************************************************
function rpsl_site_configured(){
	$status = rpsl_db_check_configuration();
	return ($status['CACert'] && $status['RapidAuthKey'] && $status['RapidAuthCert']);
}

//*************************************************************************************
//*************************************************************************************
// SITE CONFIGURATION / REGISTRATION
//*************************************************************************************
//*************************************************************************************

//*************************************************************************************
// This generates a new rapid request ID and QR registration code URL
// QR code contains: <version>S<platform>#<site name>#<request ID>#<login name>#<url>
//*************************************************************************************
function rpsl_generate_site_registration_qrcode() {
	global $wpdb;

	if(!current_user_can('administrator')) {
		rpsl_diag("User does not have permissions to generate site registration QR Code");
		die;
	}
	
	// Generate a pseudo-random ID to map the QRCode to the certificates being received
	$rpsl_requestid = rpsl_UUID::v4();
	$ht_sessionid = session_id();
	$anonid = rpsl_UUID::v4();

	$currentuser = wp_get_current_user();
	$loginname = sanitize_text_field( $currentuser->user_login );
	
	$table_name = $wpdb->prefix . "rpsl_sessions";
	
	// Need to store the $anonid in the session row

	// Add an entry to the sessions table so we can track the confirmation and add the device
	// Note the rpsl_session must be the new UUID,  not the RapID request ID
	$insert = $wpdb->prepare("INSERT INTO " . $table_name .	" (sessionid, rpsession, loginname, action, requested, uuid) " .
				"VALUES (%s, %s, %s, 'site_registration', Now(), %s)", $ht_sessionid, $rpsl_requestid, $loginname, $anonid);
	$results = $wpdb->query( $insert );

	$qr_data = rpsl_qr_data("S", $rpsl_requestid, $loginname, $anonid);
	$qr_base64 = rpsl_qr_base64($qr_data);
	rpsl_trace("New Site Registration QR created for:  $qr_data");
		
	$response_array = array ( 'rpsessionid'=>$rpsl_requestid, 'qrbase64'=>$qr_base64, 'qrData'=>$qr_data);
	
	rpsl_echo(json_encode($response_array));
	rpsl_diag("New Site Registration Request: $rpsl_requestid, user: $loginname ");

	die; // Always die in functions echoing Ajax content
}

//*************************************************************************************
// This Ajax function is used by the phone to upload the certificates to the WordPress site.
//*************************************************************************************

function rpsl_site_registration() {
	global $wpdb;
	
	rpsl_trace("Entering rpsl_site_registration for Site Registration Attempt");
	$jsonData = json_decode(file_get_contents('php://input'));
	$dataSupplied = isset($jsonData->requestid) && isset($jsonData->tic) && isset($jsonData->sac) &&
					!empty($jsonData->requestid) && !empty($jsonData->tic) && !empty($jsonData->sac);
    	
	if(!$dataSupplied) {
	    $message = json_encode(array("status"=>500, "error"=>"Minimum data of requestId, Tic and Sac not supplied."));
		rpsl_echo($message);
		die;
	}
	
	// Extract Properties for now..
	$request_id = $jsonData->requestid;
	$tic = $jsonData->tic;
	$sac = $jsonData->sac;

	$admin_credential_collected = isset($jsonData->adminCredentialCollected) ? $jsonData->adminCredentialCollected == true : false;
	$device_name = empty($jsonData->deviceName) ? "Administrators Device" : $jsonData->deviceName;

	// Look for an 'site_registration' entry in the session table - use a SQL escaped method:
	$table_name = $wpdb->prefix . "rpsl_sessions";
	$select = $wpdb->prepare("SELECT * FROM " . $table_name . " WHERE rpsession = %s AND action = 'site_registration'", $request_id );
	$sessionrow = $wpdb->get_row($select);

	if (!isset($sessionrow->sessionid)) {
	    $message = json_encode(array("status"=>500, "error"=>"SessionId not found in database.")); 
		rpsl_echo($message);
		die;
	}
	$sessionid = $sessionrow->sessionid;
	
	//Need to save the certificates, Import Sac
	$sac_content = base64_decode($sac);
	$pfxResult = rpsl_import_sac_certificate($sac_content, $sessionid);
	$issuerCertResult = rpsl_add_issuer_certificate($tic);
	
	if(!$pfxResult || !$issuerCertResult) {
		$message = json_encode(array("status"=>500, "error"=>"Parsing and saving of certificate files failed."));
		rpsl_echo($message);
		die;
	}

	rpsl_diag("Admin Credential Collected by mobile device: $admin_credential_collected");
	if($admin_credential_collected && isset($sessionrow->uuid) && isset($sessionrow->loginname)) {
		
		$rpsl_uuid = $sessionrow->uuid; // Get uuid from session row. 
		$loginname = $sessionrow->loginname; // Get loginname from session row
		
		rpsl_diag("Loginname and UUID exist on the session row, Attempting to add user if $loginname exists");

		// Add device link from user to uuid.
		$user = get_user_by('login', $loginname);

		if($user !== false) {
			rpsl_diag("Adding Device for $loginname, $rpsl_uuid, $device_name");
			rpsl_add_device( $user->ID, $rpsl_uuid, $device_name);
		}
	}

	rpsl_create_session_token_file($request_id, null);
	rpsl_delete_session_row($request_id);

	rpsl_diag("New WordPress site has been configured successfully");
	$message = json_encode(array("status"=>200));
	rpsl_echo($message);	
	die; // Always die in functions echoing Ajax content
}